; !!! For checking with aligned string, define (uncomment) next macro:
; CHECK_AS_ALIGNED = 1

CrashIt = 0	; the "SSE1" algos will bang their head against the VirtualAlloc boundary

.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm
LOOP_COUNT	= 1000000

a16 MACRO
	align 16
	REPEAT 16
		INT 3
	ENDM
ENDM

CodeSize MACRO algo
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, "bytes for &algo&", 13, 10
  ife CrashIt
  push Src
  call algo
  .if eax!=Magic
	print str$(eax), " - ERROR", 13, 10
  .endif
  endif
  popad
ENDM

.data
align 16
ifndef CHECK_AS_ALIGNED
	db 9 dup (0)
endif
Magic = SIZEOF xSrc-1
if CrashIt
	xSrc	db 1 dup("Too short"), 0
else
	xSrc	db 1 dup("This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos."), 0
endif
db 5 dup (123)

Src	dd xSrc
vaPtr	dd 0

.code
start:
	push 1
	call ShowCpu						; print brand string and SSE level
	mov Src, rv(VirtualAlloc, 0, 4096, MEM_COMMIT, PAGE_READWRITE)
	add Src, 4096-Magic-1				; go near the boundary
	mov vaPtr, eax
	invoke lstrcpy, Src, offset xSrc
;	CodeSize MbStrLen1
;	CodeSize MbStrLen2
;	CodeSize MbStrLen3
	CodeSize MbStrLen4a
	CodeSize MbStrLen4aP4
	CodeSize MbStrLen4aP42
;	CodeSize MbStrLen4b
;	CodeSize MbStrLen5
;	CodeSize AxStrLenMMX
	CodeSize AxStrLenSSE1
	CodeSize AxStrLenSSE1j
;	CodeSize StrLen
	print chr$("------- timings -------", 13, 10)
	rct = 4
	REPEAT rct
	push eax
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push Src
		call szLen
	counter_end
	print str$(eax), 9, "cycles for szLen", 13, 10

;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push Src
;		call MbStrLen1
;	counter_end
;	print str$(eax), 9, "cycles for MbStrLen1", 13, 10

;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push Src
;		call MbStrLen2
;	counter_end
;	print str$(eax), 9, "cycles for MbStrLen2", 13, 10

;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push Src
;		call MbStrLen3
;	counter_end
;	print str$(eax), 9, "cycles for MbStrLen3", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push Src
		call MbStrLen4a
	counter_end
	print str$(eax), 9, "cycles for MbStrLen4a", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push Src
		call MbStrLen4aP4
	counter_end
	print str$(eax), 9, "cycles for MbStrLen4aP4", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push Src
		call MbStrLen4aP42
	counter_end
	print str$(eax), 9, "cycles for MbStrLen4aP42", 13, 10

;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push Src
;		call MbStrLen4b
;	counter_end
;	print str$(eax), 9, "cycles for MbStrLen4b", 13, 10

;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push Src
;		call MbStrLen5
;	counter_end
;	print str$(eax), 9, "cycles for MbStrLen5", 13, 10
	
;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push Src
;		call AxStrLenMMX
;	counter_end
;	print str$(eax), 9, "cycles for AxStrLenMMX", 13, 10
	
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push Src
		call AxStrLenSSE1
	counter_end
	print str$(eax), 9, "cycles for AxStrLenSSE1", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push Src
		call AxStrLenSSE1j
	counter_end
	print str$(eax), 9, "cycles for AxStrLenSSE1j", 13, 10

;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push Src
;		call StrLen
;	counter_end
;	print str$(eax), 9, "cycles for StrLen", 13, 10
	print chr$(13, 10)
	ENDM
	
	add esp, rct*4
	invoke VirtualFree, vaPtr, 0, MEM_RELEASE
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

a16
MbStrLen1_s:
MbStrLen1 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
;int 3
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	; nop	; one nop means align 16 for innermost loop but has no effect on Celeron
	push edx	; edx preserved because Masm32 szLen preserves it
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+12]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	pop edx
	pop ecx
	ret 4
MbStrLen1 endp
MbStrLen1_endp:
a16
MbStrLen2_s:
MbStrLen2 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	xtrabytes = 8+16
	mov eax, [esp+4]	; get the src pointer
	sub esp, xtrabytes
	mov [esp], ecx	; Mb ABI: ecx is safe ;-)
	mov [esp+4], edx	; edx preserved because Masm32 szLen preserves it
	movups [esp+8], xmm0
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+4+xtrabytes]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	mov ecx, [esp]	; Mb ABI: ecx is safe ;-)
	mov edx, [esp+4]	; edx preserved because Masm32 szLen preserves it
	movups xmm0, [esp+8]
	add esp, xtrabytes
	ret 4
MbStrLen2 endp
MbStrLen2_endp:
a16
MbStrLen3_s:
MbStrLen3 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	xtrabytes = 16
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	movdqu [esp], xmm0
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+12+xtrabytes]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	movups xmm0, [esp]
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen3 endp
MbStrLen3_endp:

a16
MbStrLen4a_s:
MbStrLen4a proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
xtrabytes	= 16
forP4	= 0
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	ife forP4
		movlps qword ptr [esp], xmm0
		movhps qword ptr [esp+8], xmm0
	else
		movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	ife forP4
		movlps xmm0, qword ptr [esp]
		movhps xmm0, qword ptr [esp+8]
	else
		lddqu xmm0, oword ptr [esp]
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4a endp
MbStrLen4a_endp:

a16
MbStrLen4aP4_s:
MbStrLen4aP4 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
xtrabytes	= 16
forP4	= 1
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	ife forP4
		movsd qword ptr [esp], xmm0
		movhpd qword ptr [esp+8], xmm0
	else
;		movsd qword ptr [esp], xmm0	; not faster; [url=http://wikis.sun.com/display/BluePrints/Instruction+Selection]link[/url]
;		movhpd qword ptr [esp+8], xmm0
		movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	ife forP4
		movlps xmm0, qword ptr [esp]
		movhps xmm0, qword ptr [esp+8]
	else
		lddqu xmm0, oword ptr [esp]
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4aP4 endp
MbStrLen4aP4_endp:

a16
MbStrLen4aP42_s:
MbStrLen4aP42 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
xtrabytes	= 16
forP4	= 1
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	ife forP4
		movlps qword ptr [esp], xmm0
		movhps qword ptr [esp+8], xmm0
	else
		movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	ife forP4
		movlps xmm0, qword ptr [esp]
		movhps xmm0, qword ptr [esp+8]
	else
		movdqu xmm0, oword ptr [esp]	; SSE2
;		lddqu xmm0, oword ptr [esp]		; SSE3
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4aP42 endp
MbStrLen4aP42_endp:

a16
MbStrLen4b_s:
MbStrLen4b proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	;int 3
	xtrabytes = 16
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	if 0
	movlps qword ptr [esp], xmm0
	movhps qword ptr [esp+8], xmm0
	else
	movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
		push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	if 0
	movlps xmm0, qword ptr [esp]
	movhps xmm0, qword ptr [esp+8]
	else
	movups xmm0, [esp]
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4b endp
MbStrLen4b_endp:
a16
MbStrLen5_s:
MbStrLen5 proc uses ecx edx src:DWORD	; *** SSE2-safe version of 3.8.10, 59 bytes ***
LOCAL xmmbuffer[16]:BYTE
	if 1
	movlps qword ptr xmmbuffer, xmm0
	movhps qword ptr xmmbuffer+8, xmm0
	else
	movdqu [esp], xmm0
	endif
	mov eax, src	; get the src pointer
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
	push ecx
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	if 1
	movlps xmm0, qword ptr xmmbuffer
	movhps xmm0, qword ptr xmmbuffer+8
	else
	movups xmm0, [esp]
	endif
	ret
MbStrLen5 endp
MbStrLen5_endp:





OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
db 12 dup (0CCh)
AxStrLenMMX_s:
AxStrLenMMX	proc STDCALL lpszStr:DWORD	; SSE safe, because MMX :), ECX safe :), trashed last FPU reg :)
	;int 3
	mov edx,[esp+4]
	@@:
	pxor mm7,mm7		; if carry out this from loop, then loop is slower
	pcmpeqb mm7,[edx]	; if you check this, don't forgot change count of dup to 9 (not 12)
	add edx,8
	pmovmskb eax,mm7
	test eax,eax
	jz @B
	bsf eax,eax
	sub edx,[esp+4]
	lea eax,[eax+edx-8]
	ret 4
AxStrLenMMX	endp
AxStrLenMMX_endp:
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
db 11 dup (0)
AxStrLenSSE1_s:	; Jochen, I STRONGLY disagree with including alignment pre-proc stuffs to codesize.
		; This is not fair - this stuff in never been executed, so - they don't take place in
		; code cache. "Code placement" problem is really not problem of code and its "placement",
		; but problem of interconnection of code and DATA, which use code.
		; So, this code will take place in code cache only after "proc" directive.
		; Therefore, I don't include your "a16" macro to size, else your procs would have size
		; by 16 bytes long (16 int3's). So, and you don't include pre-proc alignment to CODE size,
		; this is not fair comparsion. This is DATA, not CODE! CPUs not pre-decode something, which
		; not have direct "links" from something other code. Read Intel's manuals. Therefore,
		; you can add ANY data etc after RET or unconditional JMP, and this is NOT have influence on
		; execution speed. And you can add ANY data etc BEFORE start of proc, without any influence also.
		; Any influence - result of realignment of internal loops, placement on PAGE etc only.
		;
		; I preserve ECX and XMM7 only for fair comparsion with Jochen's code. But Jochen's very non-modesty
		; include to my codesize the pre-proc alignment :(, and very modesty don't include size of his
		; a16 macro to his codesize :]
AxStrLenSSE1	proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
	;int 3
	mov edx,[esp+4]
	mov eax,[esp+4]
	add esp,-14h
	movups [esp],xmm7
	mov [esp+16],ecx
	and edx,-10h
	mov ecx,0fh
	pxor xmm7,xmm7
	and ecx,eax
	jz @F
	pcmpeqb xmm7,[edx]
	add edx,10h
	pmovmskb eax,xmm7
	shr eax,cl
	bsf eax,eax
	jnz @ret
	@@:
	align 16
	@@:
	pcmpeqb xmm7,[edx]
	add edx,16
	pmovmskb eax,xmm7
	test eax,eax
	jz @B	
	
	bsf eax,eax
	sub edx,[esp+4+16+4]
	lea eax,[eax+edx-10h]
	
	@ret:
	movups xmm7,[esp]
	mov ecx,[esp+16]
	add esp,14h
	ret 4	
	
AxStrLenSSE1	endp
AxStrLenSSE1_endp:

a16
AxStrLenSSE1j_s:
AxStrLenSSE1j	proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
	if 0
		mov edx, [esp+4]	; 82 instead of 80 bytes, 2 cycles faster on P4
		sub esp, 16	; one para for the xmm reg
	else
		pop eax
		pop edx
		sub esp, 16+8	; one para for the xmm reg, two popped regs
	endif
	movups [esp], xmm7
	test dl, 15
	jz @F
	movups xmm7, [edx]	; BANG over the head with VirtualAlloc ##############################
	pcmpeqb xmm7, @anZeroj
	add edx, 15
	pmovmskb eax, xmm7
	and edx, -16
	bsf eax, eax
	jnz @ret
	@@:
	pxor xmm7, xmm7	; zero it for aligned strings
;	align 16
	@@:
	pcmpeqb xmm7, [edx]
	add edx, 16
	pmovmskb eax, xmm7
	test eax, eax
	jz @B	
	bsf eax, eax
	sub edx, [esp+4+16]
	lea eax, [eax+edx-16]
	@ret:
	movups xmm7, [esp]
	if 1
		add esp, 16
		ret 4
	else
		add esp, 16+8
		jmp dword ptr [esp-8]	; one byte longer, same speed
	endif
	.data?
	align 16
	@anZeroj label OWORD
		dq ?,?
	.code
AxStrLenSSE1j	endp
AxStrLenSSE1j_endp:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4
StrLen_s:
StrLen proc item:DWORD

    mov     eax, [esp+4]            ; get pointer to string
    lea     edx, [eax+3]            ; pointer+3 used in the end
    push    ebp
    push    edi
    mov     ebp, 80808080h

  @@:     
  REPEAT 3
    mov     edi, [eax]              ; read first 4 bytes
    add     eax, 4                  ; increment pointer
    lea     ecx, [edi-01010101h]    ; subtract 1 from each byte
    not     edi                     ; invert all bytes
    and     ecx, edi                ; and these two
    and     ecx, ebp
    jnz     nxt
  ENDM

    mov     edi, [eax]              ; read first 4 bytes
    add     eax, 4                  ; 4 increment DWORD pointer
    lea     ecx, [edi-01010101h]    ; subtract 1 from each byte
    not     edi                     ; invert all bytes
    and     ecx, edi                ; and these two
    and     ecx, ebp
    jz      @B                      ; no zero bytes, continue loop

  nxt:
    test    ecx, 00008080h          ; test first two bytes
    jnz     @F
    shr     ecx, 16                 ; not in the first 2 bytes
    add     eax, 2
  @@:
    shl     cl, 1                   ; use carry flag to avoid branch
    sbb     eax, edx                ; compute length
    pop     edi
    pop     ebp

    ret     4

StrLen endp
StrLen_endp:
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 



ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:
OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Res	0

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
35      cycles for AxStrLenSSE1
35      cycles for AxStrLenSSE1j

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
58       bytes for MbStrLen1
80       bytes for MbStrLen4a
34       bytes for AxStrLenMMX
100      bytes for AxStrLenSSE1
81       bytes for AxStrLenSSE1j
113      bytes for StrLen

48      cycles for MbStrLen1
50      cycles for MbStrLen4a
55      cycles for MbStrLen4b
53      cycles for MbStrLen5
63      cycles for AxStrLenMMX
35      cycles for AxStrLenSSE1
35      cycles for AxStrLenSSE1j
100     cycles for StrLen

47      cycles for MbStrLen1
50      cycles for MbStrLen4a
63      cycles for MbStrLen4b
54      cycles for MbStrLen5
63      cycles for AxStrLenMMX
35      cycles for AxStrLenSSE1
35      cycles for AxStrLenSSE1j
100     cycles for StrLen

48      cycles for MbStrLen1
50      cycles for MbStrLen4a
55      cycles for MbStrLen4b
54      cycles for MbStrLen5
64      cycles for AxStrLenMMX
36      cycles for AxStrLenSSE1
35      cycles for AxStrLenSSE1j
101     cycles for StrLen